function A = compute_angles(poly)
% function A = compute_angles(poly)
% Computes the n x n dihedral angles matrix, where n is the number of faces
% faces which don't intersect are assigned a value of -10, by convention.
%
% RR


v = poly.faces;
a = poly.adjacency;

temp = size(v);
n = temp(1);

for i=1:n;
  for j =1:n;
    A(i,j) = 180-180/pi*acos(inner(v(i,:),v(j,:)));
    if (a(i,j) == 0)
      A(i,j) = -10;
    end
  end
end


