function A = compute_reflection(v)
% Given a vector v with <v,v> = 1 so that the condition <x,v>=0 defines a plane in H^3,
% this function computes the reflection the plane defined by v as a matrix A in SO(3,1)


A = zeros(4,4);

A(1,1) = 1+2*v(1)^2;
A(1,2) = 2*v(1)*v(2);
A(1,3) = 2*v(1)*v(3);
A(1,4) = 2*v(1)*v(4);

A(2,1) = -2*v(2)*v(1);
A(2,2) = 1 - 2* v(2)^2;
A(2,3) = -2*v(2)*v(3);
A(2,4) = -2*v(2)*v(4);

A(3,1) = -2*v(3)*v(1);
A(3,2) = -2*v(3)*v(2);
A(3,3) = 1 - 2*v(3)^2;
A(3,4) = -2*v(3)*v(4);

A(4,1) = -2*v(4)*v(1);
A(4,2) = -2*v(4)*v(2);
A(4,3) = -2*v(4)*v(3);
A(4,4) = 1 - 2*v(4)^2;
