function [plane,vert_num1,vert_num2,vert_num3] = compute_truncation_plane(poly,vert_num);
  Vectors = poly.faces;
  adjacency = poly.adjacency;
  vert = poly.vert;

  faces = size(adjacency,1);
  Faces = vert;  %this matrix contains in the i-th row, the list of 3 faces
                %that intersect at face i.
  clear('S')
  vertices = size(vert,1);

  i = vert(vert_num,1);
  j = vert(vert_num,2);
  k = vert(vert_num,3);

  count = 0;

  for n = 1:vertices;
    other_count = 0;
    for m = 1:3;
      if (vert(n,m) == i | vert(n,m) == j | vert(n,m) == k)
      other_count = other_count + 1;
      end
    end
    if (other_count == 2 & count == 0);
      vert_num1 = n;
      count = count +1;
    elseif (other_count == 2 & count == 1);
      vert_num2 = n;
      count = count +1;
    elseif (other_count == 2 & count == 2);
      vert_num3 = n;
      count = count +1;
    end
  end


  vertex = compute_vertex(poly,vert_num);
  vert1 = compute_vertex(poly,vert_num1);
  vert2 = compute_vertex(poly,vert_num2);
  vert3 = compute_vertex(poly,vert_num3);

  point1 = vertex + .1*vert1;
  point1 = point1/sqrt(-inner(point1,point1));
  point2 = vertex + .1*vert2;
  point2 = point2/sqrt(-inner(point2,point2));
  point3 = vertex + .1*vert3;
  point3 = point3/sqrt(-inner(point3,point3));


  A(1,:) = point1';
  A(2,:) = point2';
  A(3,:) = point3';
  A(:,1) = -A(:,1);
  v = null(A);          %three planes
  norm = sqrt((inner(v,v)));
  v = v/norm;

  plane = v;
  %inner(plane,plane)

  if (inner(plane,poly.faces(i,:)) < 0)
    plane = -plane;
  end
