function [poly_new,whitehead,inv_whitehead] = final_comb(poly,M,num_cycle,cycle,num_interior,interior,v_inf)
%  function [poly_new,whitehead,inv_whitehead] = final_comb(poly,M,num_cycle,cycle,num_interior,interior,v_inf)
%  This is the last step of the combinatorial algorithm which puts the
%  polyhedron in canonical position, i.e. with exactly two inner vertices
%  one of which is connected to exactly three consecutive points on the outer
%  cycle. 
%
% RR 2/20/03


poly_temp = poly;

i=1;
while ((i <= num_cycle) & (M(fix_index(i,num_cycle),2) == 0 | M(fix_index(i-1,num_cycle),2) == 1))
  i = i+1;
end

num = norm(M(:,2),1);
num_moves = 0;

j = fix_index(i+num-1,num_cycle);
end_cond = fix_index(i+2,num_cycle);


while (j ~= end_cond)
   [poly_temp,k,l] = comb_whitehead(cycle(j),interior(2),poly_temp);
   num_moves = num_moves + 1;
   whitehead(num_moves,1) = cycle(j);
   whitehead(num_moves,2) = interior(2);
   inv_whitehead(num_moves,1) = k;
   inv_whitehead(num_moves,2) = l;
   j = j-1;
   j = fix_index(j,num_cycle);
end


poly_new = poly_temp;

  
 

