function [v_inf,num_cycle,cycle,num_interior,interior] = find_v_inf(poly);
% function [v_inf,num_cycle,cycle,num_interior,interior] = find_v_inf(poly);
% this function finds the vertex with the largest number of connections,
% <<v_inf>>, the outer polygon <<cycle>>, and the interior verticies
% <<interior>>.
%
% RR

a = poly.adjacency;
vert = poly.vert;

%Find v_inf
num_faces = size(a,1);
v_inf = 1;
length = 1;
for i=1:num_faces;
  this_length = norm((a(i,:)),1) - 1;  %How many ones there are in the i-th row.
  if (this_length > length)
    v_inf = i;
    length = this_length;
  end
end

v_inf


%find the unordered cycle.
n = 1;
for i=1:num_faces;
  if (a(i,v_inf) == 1 & i ~= v_inf)
    cycle(n) = i;
    n = n+1;
  end
end
  
%order the cycle cyclically.
ordered_cycle(1) = cycle(1);
for i=2:length;
  if (i == 2)
    n = 2;
    while(a(cycle(n),ordered_cycle(i-1)) == 0 | cycle(n) == ordered_cycle(i-1))
      n = n+1;
    end
    ordered_cycle(i) = cycle(n);
  else
     n = 2;
    while(a(cycle(n),ordered_cycle(i-1)) == 0 | cycle(n) == ordered_cycle(i-1) | cycle(n) == ordered_cycle(i-2))
      n = n+1;
    end
  end
    ordered_cycle(i) = cycle(n);
end

cycle = ordered_cycle;
  
%determine the interior verticies.
n = 1;
for i=1:num_faces
  m = 0;
  if (i == v_inf)
    m = 1;
  else
    for j = 1:length
      if (i == cycle(j))
        m = 1;
      end
    end
  end
  if (m == 0)
    interior(n) = i;
    n = n+1;
  end
end 

num_interior = n-1;
num_cycle = length;
