function inter_angles = intermediate_angles(angles1,angles2,m,n)
%  function inter_angles = intermediate_angles(angles1,angles2)
%  Computes midpoint between angles1 and angles2 in the polytope.
%
%  RR
faces = size(angles1,1);

if (m < n)
  for i=1:faces;
    for j=1:faces;
      if (angles1(i,j) > 0 & angles1(i,j) < 178)
        inter_angles(i,j) = ((n-m)*angles1(i,j) + m*angles2(i,j))/n;
      elseif (abs(angles1(i,j) - 180) < .1)
        inter_angles(i,j) = 180;
      else
        inter_angles(i,j) = -10;
      end
    end
  end
else
  inter_angles = angles2;
end


