function poly_out = isometry(poly_in,vert_num1,vert_num2,vert_num3)

%This takes poly_in, which has a face of three vertices and moves the
%vertices to a canonical position, with vert1 at the origin, vert2 along the
%x-axis and vert3 in the x-y plane, of the ball model.

vert1 = compute_vertex(poly_in,vert_num1);
vert2 = compute_vertex(poly_in,vert_num2);
vert3 = compute_vertex(poly_in,vert_num3);

M(1,:) = vert1';
M(2,:) = vert2';
M(3,:) = vert3';

a4 = null(M);
a4 = a4/sqrt(inner(a4,a4));

M(1,:) = vert1';
M(2,:) = vert2';
M(3,:) = a4';
M(3,1) = -M(3,1);

a3 = null(M);
a3 = a3/sqrt(inner(a3,a3));


a3'*vert3
if (real(a3'*vert3) < 0)
  a3=-a3;
end
a3'*vert3

M(1,:) = vert1';
M(2,:) = a3';
M(2,1) = -M(2,1);
M(3,:) = a4';
M(3,1) = -M(3,1);

a2 = null(M);
a2 = a2/sqrt(inner(a2,a2));

a2'*vert2

if (real(a2'*vert2) < 0)
  a2=-a2;
end
a2'*vert2

M(1,:) = a2';
M(1,1) = -M(1,1);
M(2,:) = a3';
M(2,1) = -M(2,1);
M(3,:) = a4';
M(3,1) = -M(3,1);

a1 = null(M);
a1 = a1/sqrt(-inner(a1,a1));

A(1,:) = a1';
A(2,:) = a2';
A(3,:) = a3';
A(4,:) = a4';

if (det(A) < 0)
  A(1,:) = -A(1,:);
end

faces = poly_in.faces;
num_faces = size(faces,1);
faces = (A*faces')';

poly_out = poly_in;
poly_out.faces = faces;






