function poly = load_poly(filename)
%  function poly = load_poly(filename)
%  Loads a polygon that is stored in the geomview *.off (Object format) File.
%
%  RR 

% load the data



fid = fopen(filename,'r');

size = fscanf(fid,'%f',[1,3]);
num_vertices = size(1);
num_faces = size(2);

V = zeros(4,num_vertices);
V(2:4,:) = fscanf(fid,'%f',[3,num_vertices]);
V = V';

for i = 1:num_faces;
  num_vert_in_face = fscanf(fid,'%f',[1]);
  faces(i,1) =  num_vert_in_face;
  vert_in_face = fscanf(fid,'%f',[1, num_vert_in_face]);
  faces(i,2:num_vert_in_face+1) = vert_in_face;
  fscanf(fid,'%f',[1]);  %strip off the color data.
end






for i=0:num_vertices-1;
  n = 1;
  for j =1:num_faces
    for k=2:faces(j,1)+1
      if (faces(j,k) == i)
        vertices_spec(i+1,n) = j;
        n = n+1;
      end
    end
  end
end

vertices_spec;




%convert the vertices to 4-vectors on the hyperboloid:

for n=1:num_vertices
  r_squared = (V(n,2)^2+V(n,3)^2+V(n,4)^2);
  V(n,:) = V(n,:)/(1-r_squared);
  V(n,1) = sqrt(1+V(n,2)^2+V(n,3)^2+V(n,4)^2);
end

V;


temp = V(1:3,:);
temp(:,1) = -temp(:,1);
null(temp);

  

%now we need to use the faces array to compute the vectors in the dual
%hyperboloid that describe the faces.



center_of_poly = center_poly(V,num_vertices);

for m=1:num_faces
  D(1,:)=V(faces(m,2)+1,:);
  D(2,:)=V(faces(m,3)+1,:);
  D(3,:)=V(faces(m,4)+1,:);

  D(:,1)=-D(:,1);

  temp = null(D);
  norm = sqrt(abs(inner(temp,temp)));
  temp = temp/norm;
  %center_of_poly = [1 0 0 0];
  if (inner(center_of_poly,temp) < 0)  %make sure that the half-space
    temp = -temp;			%specified by v contains the 
  end					%inside of the polyhedron.
  Vectors(m,:) = temp';
end


%Compute the adjacency matrix:

faces;

adjacency = zeros(num_faces,num_faces);

for f1 = 1:num_faces
  for f2 = f1:num_faces

    n = 0;
    for i = 1:faces(f1,1)
      for j = 1:faces(f2,1)
        if (faces(f1,i+1) == faces(f2,j+1))
	  n = n + 1;
	end
      end
    end
    if (n >= 2)
      adjacency(f1,f2) = 1;
      adjacency(f2,f1) = 1;
    end

  end
end

poly.faces = Vectors;
poly.adjacency = adjacency;
poly.vert = vertices_spec;
