function poly_out = make(comb_poly);

warning off 
% surpress the nasty warning messages.

[p,wh,iwh] = comb_algorithm(comb_poly);
iwh

num_moves = size(iwh,1);
faces = size(comb_poly.adjacency,1);

disp('-------------------------------------------------------------------')
disp(num_moves);
disp('Whitehead moves are required.  Press <<Enter>> to continue!')
pause

%generate the primitive geometric element, that is, the double prism.
p = prim(faces);

err = 0;
for i=1:num_moves;
  iwh(num_moves+1-i,:)
  p = whitehead(iwh(num_moves+1-i,1),iwh(num_moves+1-i,2),p);
  num = num2str(i);
  filename = ['poly',num,  '.off']
  write_poly(p,filename)
  if (is_convex(p) == 0)
    disp('Convexity error: tune parameters...')
    err = 1;
    break;
  end
  if (is_compact(p) == 0)
    disp('Compactness error: tune parameters...')
    err = 2;
    break;
  end
  disp('------------------------------------------------------------------')
  disp('Move');
  disp(i);
  disp('completed');
  disp('------------------------------------------------------------------')
end

if (err == 0)
  poly_out = p;
else
  poly_out = comb_poly;
end
