function [newV,determinant,J,accur] = newton(V,angles,face_i,face_j,face_k,vertex1,vertex2)
%  function newV = newton(V,angles,face_i,face_j,face_k,vertex1,vertex2)
%  Helper function that preforms a single iteration of newton's method.
%
%  RR


temp = size(angles);
N = temp(1);  %the number of faces

B = reshape(V',4*N,1);

Vectors = zeros(N,4);
for i=1:N
  for j=1:4
    Vectors(i,j) = B(4*(i-1)+j);
  end
end


J = zeros(4*N,4*N);
J(1,4*(face_i-1)+1) = 1;
J(2,4*(face_i-1)+3) = 1;
J(3,4*(face_i-1)+4) = 1;
J(4,4*(face_j-1)+1) = -vertex1(1);
J(4,4*(face_j-1)+2) = vertex1(2);
J(4,4*(face_j-1)+3) = vertex1(3);
J(4,4*(face_j-1)+4) = vertex1(4);
J(5,4*(face_j-1)+1) = -vertex2(1);
J(5,4*(face_j-1)+2) = vertex2(2);
J(5,4*(face_j-1)+3) = vertex2(3);
J(5,4*(face_j-1)+4) = vertex2(4);
J(6,4*(face_k-1)+1) = -vertex1(1);
J(6,4*(face_k-1)+2) = vertex1(2);
J(6,4*(face_k-1)+3) = vertex1(3);
J(6,4*(face_k-1)+4) = vertex1(4);


count = 7;

for i=1:N
  for j=i:N
    if(angles(i,j) > -1)
      if (i==j)
        J(count,4*(i-1)+1) = -2*Vectors(i,1);
	J(count,4*(i-1)+2) = 2*Vectors(i,2);
	J(count,4*(i-1)+3) = 2*Vectors(i,3);
	J(count,4*(i-1)+4) = 2*Vectors(i,4);
      else
        J(count,4*(i-1)+1) = -Vectors(j,1);
	J(count,4*(i-1)+2) = Vectors(j,2);
	J(count,4*(i-1)+3) = Vectors(j,3);
	J(count,4*(i-1)+4) = Vectors(j,4);
        J(count,4*(j-1)+1) = -Vectors(i,1);
	J(count,4*(j-1)+2) = Vectors(i,2);
	J(count,4*(j-1)+3) = Vectors(i,3);
	J(count,4*(j-1)+4) = Vectors(i,4);
      end
      count = count +1;
    end
  end
end


determinant = det(J);
%A = B - J^(-1)*f(B,angles,face_i,face_j,face_k,vertex1,vertex2);
C = f(B,angles,face_i,face_j,face_k,vertex1,vertex2);
A = B - J\C;
accur = norm(C,2);
%nor = norm(J^(-1),'fro');
%nor^2*accur

newV = reshape(A,4,N);
newV = newV';
