function poly_out = newton_iter(poly_in,angles,vertex_number,tol)
%  function poly_out = newton_iter(poly_in,angles,vertex_number,tol)
%  Solves for the requested polygon <poly_out> with Newton's method,
%  using the input poly <poly_in>.
%
%  RR


v = poly_in.faces;
a = poly_in.adjacency;
vert = poly_in.vert;

initial_angles = compute_angles(poly_in);

v_iter = v;

face_i = vert(vertex_number,1);
face_j = vert(vertex_number,2);
face_k = vert(vertex_number,3);

vertex1 = solve_for_vertex(v,a,vert,face_i,face_j,face_k);

n = 1;
while((a(face_i,n) ~= 1) | (a(face_j,n) ~= 1) | (n == face_i) | (n == face_j) | (n == face_k))
  n = n+1;
end
vertex2 = solve_for_vertex(v,a,vert,face_i,face_j,n);
vertex2 = vertex2(:,1);

i = 1;
determinant = 1;
accur = 0;
%while ((i < 20 & determinant < 1e20) & error < 100)
while (i < 30  & accur < 2)
%while (i < 20)
  s = size(angles);
  faces = s(1);
  temp = reshape(v_iter',4*faces,1);
  accur = norm(f(temp,angles,face_i,face_j,face_k,vertex1,vertex2),inf);
  if (accur <= tol)
    poly_out.faces = v_iter;
    poly_out.adjacency = poly_in.adjacency;
    poly_out.vert = poly_in.vert;
    break
  end
  %accur
  [v_iter,determinant] = newton(v_iter,angles,face_i,face_j,face_k,vertex1,vertex2);
  i = i+1;
end


if(accur < tol)
  v_out = v_iter;
else 
  disp('trying again');
  midpoint = intermediate_angles(initial_angles,angles,1,2);
  poly_mid = newton_iter(poly_in,midpoint,vertex_number,tol);
  disp('second half');
  poly_out = newton_iter(poly_mid,angles,vertex_number,tol);
end

