function poly_out = newton_iter2(poly_in,angles,vertex_number,tol,divisions)
%  function poly_out = newton_iter2(poly_in,angles,vertex_number,tol,divisions)
%  Solves for the requested polygon <poly_out> with Newton's method,
%  using the input poly <poly_in>.
%
%  RR


poly_out = poly_in;
v = poly_in.faces;
a = poly_in.adjacency;
vert = poly_in.vert;

initial_angles = compute_angles(poly_in);

v_iter = v;

face_i = vert(vertex_number,1);
face_j = vert(vertex_number,2);
face_k = vert(vertex_number,3);

vertex1 = solve_for_vertex(v,a,vert,face_i,face_j,face_k);

n = 1;
while((a(face_i,n) ~= 1) | (a(face_j,n) ~= 1) | (n == face_i) | (n == face_j) | (n == face_k))
  n = n+1;
end
vertex2 = solve_for_vertex(v,a,vert,face_i,face_j,n);
vertex2 = vertex2(:,1);

for j=1:divisions;
  if (mod(j,10) == 0)
    disp('*')
  end
  poly_in = poly_out;
  v = poly_in.faces;
  a = poly_in.adjacency;
  vert = poly_in.vert;
  current_angles = intermediate_angles(initial_angles,angles,j,divisions);
  i = 1;
  determinant = 1;
  accur = 0;
  while (i < 10)
    s = size(current_angles);
    faces = s(1);
    temp = reshape(v_iter',4*faces,1);
    accur = norm(f(temp,current_angles,face_i,face_j,face_k,vertex1,vertex2),inf);
    if (accur <= tol)
      poly_out.faces = v_iter;
      poly_out.adjacency = poly_in.adjacency;
      poly_out.vert = poly_in.vert;
      break
    end
    [v_iter,determinant,J,accur] = newton(v_iter,current_angles,face_i,face_j,face_k,vertex1,vertex2);
    if (i == 1 & mod(j,10) == 0)
      %accur
      %(norm(J^(-1),'fro'))^2*accur
      %nor = norm(J,'fro')
      %inor = norm(J^(-1),'fro')
    end
    i = i+1;
  end
  if (mod(j,10) == 0)
   %i
  end
end
