%  function [poly_new,whitehead,inv_whitehead] = old_cond__cycle(poly,M,num_cycle,cycle,num_interior,interior,v_inf)
% Given, the interior->cycle matrix M, the cycle, the interior, and v_inf
% this program determines the necessary whitehead moves to increase the number
% on edges in the interior polygon by 1.
%
% This is the old, incorrect technology, from Andreev.
%
% RR 11/16/02


function [poly_new,whitehead,inv_whitehead] = old_cond_cycle(poly,M,num_cycle,cycle,num_interior,interior,v_inf)

%first, determine the number of components of parts of the cycle which connect
%to any specific interior vertex:

poly_temp = poly;  % so that you don't mess up the initial poly.
whitehead = [0 0];  % just to cue up whitehead, later will be fixed.
inv_whitehead = [0 0];  % just to cue up inv_whitehead, later will be fixed.

N = zeros(num_interior,1);
for i=1:num_interior
  j = 1;
  N(i) = 0;
  while (j <= num_cycle)
    if (j == 1)
      if (M(1,i) == 1)
        N(i) = N(i) + 1;
      end
    else 
      if (M(j,i) == 1 & M(j-1,i) == 0)
        N(i) = N(i) + 1;
      end
    end
    j = j+1;
  end
  if (M(1,i) == 1 & M(num_cycle,i) == 1)
    N(i) = N(i) - 1;
  end
end


N	%this is the number of components in the outer poly of the closed star

num_moves = 0;

a = poly_temp.adjacency;
for i=1:num_interior
  while (N(i) > 1)
  disp('******')
     %decreas N(i) by one.
     % eliminate extra components!!
     j = 1;
     while(M(j,i) == 1)
       j = j+1;
     end
     while(M(j,i) == 0)
       j = j+1;
     end
     while(M(j,i) == 1)
       [poly_temp,k,l] = comb_whitehead(cycle(j),interior(i),poly_temp);
       num_moves = num_moves + 1;
       whitehead(num_moves,1) = cycle(j);      
       whitehead(num_moves,2) = interior(i);      
       inv_whitehead(num_moves,1) = k;      
       inv_whitehead(num_moves,2) = l;      
       j = j+1;
     end
     %need to update N and M.
     N(i) = N(i)-1
     M = interior_to_cycle(poly_temp,num_cycle,cycle,num_interior,interior)
  end
end

%make sure that N(i) = 1 or 0 for each i.
%these moves don't affect the data 
% [num_cycle,cycle,num_interior,interior]
N = zeros(num_interior,1);
for i=1:num_interior
  j = 1;
  N(i) = 0;
  while (j < num_cycle)
    if (j == 1)
      if (M(j,i) == 1)
        N(i) = N(i) + 1;
      end
    else 
      if (M(j,i) == 1 & M(j-1,i) == 0)
        N(i) = N(i) + 1;
      end
    end
    j = j+1;
  end
end

%compute M again.   ****

M = interior_to_cycle(poly_temp,num_cycle,cycle,num_interior,interior);


%we now have an inner polyhedron, like in the proof on Andreev's theorem.
%find an element and make sure that it is only adjacent to 2 elts of the
%outer poly.
i = 1;
while(sum(M(:,i)) < 2)
  i = i+1;
end

i

%***could search for the one having smallest num_cycle_connected
%to reduce the number of whitehead moves that one has to do.
num_cycle_connected = sum(M(:,i))  %how many on the outer cycle is
                                    %is attached to.

%cue up to the first edge of the cycle that vertex i is connected to
j = 1;
while(M(j,i) == 0)
  j = j+1;
end
%do whitehead moves to eliminate the first (num_cycle_connected-2)
%connections

j

num_recent = 0;
for m = 1:(num_cycle_connected-2)
  [poly_temp,k,l] = comb_whitehead(interior(i),cycle(j+m-1),poly_temp);
  k
  l
  num_moves = num_moves + 1;
  num_recent = num_recent + 1;
  whitehead(num_moves,1) = interior(i);
  whitehead(num_moves,2) = cycle(j+m-1);
  inv_whitehead(num_moves,1) = k;
  inv_whitehead(num_moves,2) = l;
end

temp = j+num_recent

%now we are free to do the whitehead move connecting i to v_inf.

[poly_temp,k,l] = comb_whitehead(cycle(temp),cycle(temp+1),poly_temp);
num_moves = num_moves + 1;
whitehead(num_moves,1) = cycle(temp);
whitehead(num_moves,2) = cycle(temp+1);
inv_whitehead(num_moves,1) = k;
inv_whitehead(num_moves,2) = l;

poly_new = poly_temp;
