function prim = primitive(n)
%  function prim = primitive(n)
%  Creates a prism, and does the two whitehead moves to make the basic geom
%  primitive for andreev's theorem.
%
%  RR 12/12/02



poly = prism(n-2);

%  Now we will do the two delicate whitehead moves.

angles = compute_angles(poly);

angles(1,3) = 5;
angles(3,1) = 5;
angles(3,4) = 89;
angles(4,3) = 89;
angles(n,3) = 89;
angles(3,n) = 89;
angles(4,1) = 89;
angles(1,4) = 89;
angles(n,1) = 89;
angles(1,n) = 89;

poly1 = newton_iter2(poly,angles,6,1e-6,10);
write_poly(poly1,'temp.off')





%prepare for the first whitehead move.
angles(n,4) = 5;
angles(4,n) = 5;
angles(1,3) = -10;
angles(3,1) = -10;


disp('doing whitehead move on edge (1,3).')
poly2 = newton_iter2(poly1,angles,6,1e-6,1);

poly2.adjacency(1,3) = 0;
poly2.adjacency(3,1) = 0;
poly2.adjacency(n,4) = 1;
poly2.adjacency(4,n) = 1;

poly2.vert(1,:) = [3 4 n];
poly2.vert(2,:) = [1 4 n];

write_poly(poly2,'temp2.off')



angles(n,4) = 40;
angles(4,n) = 40;
angles(n,2) = 30;
angles(2,n) = 30;
angles(n-1,n) = 89;
angles(n,n-1) = 89;
angles(2,n-1) = 72;
angles(n-1,2) = 72;
angles(2,3) = 89;
angles(3,2) = 89;
angles(3,4) = 72;
angles(4,3) = 72;
angles_in_polytope(poly2,angles)

poly3 = newton_iter2(poly2,angles,6,1e-6,10);
write_poly(poly3,'temp3.off')

angles(n,4) = 72;
angles(4,n) = 72;
angles(n,2) = 5;
angles(2,n) = 5;
angles(2,n-1) = 89;
angles(n-1,2) = 89;
poly4 = newton_iter2(poly3,angles,6,1e-6,10);
write_poly(poly4,'temp4.off')

angles(n,2) = -10;
angles(2,n) = -10;
angles(n-1,3) = 5;
angles(3,n-1) = 5;

poly5 = newton_iter2(poly4,angles,6,1e-6,1);

poly5.adjacency(n,2) = 0;
poly5.adjacency(2,n) = 0;
poly5.adjacency(3,n-1) = 1;
poly5.adjacency(n-1,3) = 1;

num_vert = size(poly3.vert,1)
poly5.vert(num_vert,:) = [2 3 n-1];
poly5.vert(num_vert/2+1,:) = [3 n-1 n];

write_poly(poly5,'temp5.off')

prim = canonical(poly5,20);
