function poly = prism(n)
%  function poly = prism(n)
%  creates an n-sided prism






num_vertices = 2*n;
num_faces = n+2;

for i=1:n
  verticies(i,2) = .95*cos(i*2*pi/n);
  verticies(i,3) = .95*sin(i*2*pi/n);
  verticies(i,4) = -.2;
end
  
for i=n+1:2*n
  verticies(i,2) = .95*cos(i*2*pi/n);
  verticies(i,3) = .95*sin(i*2*pi/n);
  verticies(i,4) = .2;
end

V = verticies;

faces(1,1) = n;
faces(2,1) = n;
for i=1:n;
  faces(1,i+1) = i-1;
  faces(2,i+1) = n+i-1;
end

for i=1:n
  faces(i+2,1) = 4;
  faces(i+2,2) = i-1;
  if (i < n)
    faces(i+2,3) = i;
    faces(i+2,4) = n+i;
  else
    faces(i+2,3) = 0;
    faces(i+2,4) = n;
  end
  faces(i+2,5) = n+i-1;
end



for i=0:num_vertices-1;
  n = 1;
  for j =1:num_faces
    for k=2:faces(j,1)+1
      if (faces(j,k) == i)
        vertices_spec(i+1,n) = j;
        n = n+1;
      end
    end
  end
end

%convert the vertices to 4-vectors on the hyperboloid:

for n=1:num_vertices
  r_squared = (V(n,2)^2+V(n,3)^2+V(n,4)^2);
  V(n,:) = V(n,:)/(1-r_squared);
  V(n,1) = sqrt(1+V(n,2)^2+V(n,3)^2+V(n,4)^2);
end

V;
temp = V(1:3,:);
temp(:,1) = -temp(:,1);
null(temp);



%now we need to use the faces array to compute the vectors in the dual
%hyperboloid that describe the faces.



center_of_poly = center_poly(V,num_vertices);

for m=1:num_faces
  D(1,:)=V(faces(m,2)+1,:);
  D(2,:)=V(faces(m,3)+1,:);
  D(3,:)=V(faces(m,4)+1,:);

  D(:,1)=-D(:,1);

  temp = null(D);
  norm = sqrt(abs(inner(temp,temp)));
  temp = temp/norm;
  %center_of_poly = [1 0 0 0];
  if (inner(center_of_poly,temp) < 0)  %make sure that the half-space
    temp = -temp;                       %specified by v contains the
  end                                   %inside of the polyhedron.
  Vectors(m,:) = temp';
end

%Compute the adjacency matrix:

faces;

adjacency = zeros(num_faces,num_faces);

for f1 = 1:num_faces
  for f2 = f1:num_faces

    n = 0;
    for i = 1:faces(f1,1)
      for j = 1:faces(f2,1)
        if (faces(f1,i+1) == faces(f2,j+1))
          n = n + 1;
        end
      end
    end
    if (n >= 2)
      adjacency(f1,f2) = 1;
      adjacency(f2,f1) = 1;
    end

  end
end

poly.faces = Vectors;
poly.adjacency = adjacency;
poly.vert = vertices_spec;


if (num_faces > 5)
  poly = canonical(poly,100);
end

