function poly = canonical(poly_init,angle)
%puts a 3-aprismatic polyhedron in the 'canonical position', with all the 
%dihedral angles at 2/5*pi, or 72 degrees.
%
% RR 9/6/02
%

v_init = poly_init.faces;
a_init = poly_init.adjacency;
vert_init = poly_init.vert;

%check if three aprismatic.  
if(is_3prismatic(poly_init) == 1)
  disp('Trying to put a three-prismatic polyhedron in canonical position.')
  pause
end

faces = size(a_init,1);

a = a_init;
vert = vert_init;

angles = compute_angles(poly_init);

%notice that only the upper-right triangle of the angles matrix is needed to
%specify the angles, and only it is used by newton's method.

for i=1:faces;for j=i+1:faces;if (angles(i,j) > 0);angles(i,j) = angle;end;end;end

poly = newton_iter2(poly_init,angles,5,1e-8,10);
poly = newton_iter2(poly,angles,5,1e-10,10);
poly= center_my_poly(poly);
poly = newton_iter2(poly,angles,5,1e-12,10);
poly= center_my_poly(poly);
poly = newton_iter2(poly,angles,5,1e-15,10);


