function vertex = solve_for_vertex(v,a,vert,i,j,k)
%  function vertex = solve_for_vertex(v,a,vert,i,j,k)
%  Given three intersecting faces, (i,j,k), this function solves for their 
%  vertex.
%
%  RR


A(1,:) = v(i,:);
A(2,:) = v(j,:);
A(3,:) = v(k,:);

A(:,1) = -A(:,1);

vertex = null(A);  %the vertex in the hyperboloid is skew orthogonal
		   %to each of the three faces.

norm = sqrt(-(inner(vertex,vertex)));
vertex = vertex/norm;
if vertex(1) < 0
 vertex = -vertex;
end

