function poly_out = truncate_vertex(poly_in,vert_num);

  plane = compute_truncation_plane(poly_in,vert_num)
  poly_out = poly_in;

  num_faces = size(poly_in.faces,1);
  num_vert = size(poly_in.vert,1);

  i = poly_in.vert(vert_num,1);
  j = poly_in.vert(vert_num,2);
  k = poly_in.vert(vert_num,3);

  poly_out.faces(num_faces+1,:) = plane';
  poly_out.vert(vert_num,:) = [i j num_faces+1];
  poly_out.vert(num_vert+1,:) = [i k num_faces+1];
  poly_out.vert(num_vert+2,:) = [j k num_faces+1];

  poly_out.adjacency(num_faces+1,i) = 1;
  poly_out.adjacency(num_faces+1,j) = 1;
  poly_out.adjacency(num_faces+1,k) = 1;
  poly_out.adjacency(num_faces+1,num_faces+1) = 1;
  
  poly_out.adjacency(i,num_faces+1) = 1;
  poly_out.adjacency(j,num_faces+1) = 1;
  poly_out.adjacency(k,num_faces+1) = 1;
  

  angles = compute_angles(poly_out);
  angles(i,j) = 50;
  angles(j,i) = 50;
  angles(i,k) = 50;
  angles(k,i) = 50;
  angles(j,k) = 50;
  angles(k,j) = 50;
  angles(i,num_faces+1) = 90;
  angles(num_faces+1,i) = 90;
  angles(j,num_faces+1) = 90;
  angles(num_faces+1,j) = 90;
  angles(k,num_faces+1) = 90;
  angles(num_faces+1,k) = 90;

  if (angles_in_polytope(poly_out,angles) == 0)
    disp('These angles are not allowable!')
    pause
  end
  poly_out = newton_iter2(poly_out,angles,3,1e-8,10);
  
  
