%this program takes a polyhedron and perfomes a whitehead move on an edje (i,j)
% where i and j label faces

% RR 9/5/02

function [v,a,vert] = whitehead(i,j,v_init,a_init,vert_init)

%dimensions
faces = size(a_init,1);
vertices = size(vert_init,1);


if (a_init(i,j) ~= 1)
  disp('There is no edje (i,j), try again!');
  break
end

%first determine the other faces k and l intersect with faces i and j.
%c = 0;
%for n = 1:faces
%  if (n ~= i & n ~=j)
%    if(a_init(n,i) == 1 & a_init(n,j) == 1 & c == 0);
%      c = 1;
%      k = n;
%    elseif (a_init(n,i) == 1 & a_init(n,j) & c == 1);
%      l = n;
%      break;  %you have found both faces that intersect with faces i and j.
%    end
%  end
%end

%first determine the other faces k and l intersect with faces i and j.
init = 0;
for m = 1:vertices
  count = 0;
  for n = 1:3
    if(vert_init(m,n) == i | vert_init(m,n) == j)
      count = count +1;
    else
      temp = vert_init(m,n);
    end
  end
  if (count == 2 & init == 0)
    k = temp;
    init = 1;
    first = m;
  elseif (count == 2 & init == 1)
    l = temp;
    second = m;
    break;
  end
end
   
   


%modify vert to make it appropriate.
vert = vert_init;
vert(first,1) = i;
vert(first,2) = k;
vert(first,3) = l;
vert(second,1) = j;
vert(second,2) = k;
vert(second,3) = l;
   

angles = compute_angles(v_init,a_init);
angles(i,k) = 89.99;
angles(k,i) = 89.99;
angles(i,l) = 89.99;
angles(l,i) = 89.99;
angles(j,k) = 89.99;
angles(k,j) = 89.99;
angles(j,l) = 89.99;
angles(l,j) = 89.99;
angles(i,j) = .1;
angles(j,i) = .1;

v_temp = newton_iter(v_init,a_init,vert_init,angles,1e-10);

%this is the temporary polyhedron that will be perturbed to modify the
%combinatorics

a = a_init;
a(i,j) = 0;		%a needs to represent the new combinatorics.
a(j,i) = 0;
a(k,l) = 1;
a(l,k) = 1;

   


%solve for the polyhedron with the faces slightly shifted, so that the 
%Whitehead move has been achieved.
angles(i,j) = -10;
angles(j,i) = -10;
angles(k,l) = .1;
angles(l,k) = .1;

v_modified = newton_iter(v_temp,a,vert_init,angles,1e-10);

v = v_modified;

%[v,a,vert] = canonical(v,a,vert);

    




